<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="form-group col-md-12" :class="{'has-error': this.errors_category.name}">
                <label>Nome<b class="text-danger">*</b></label>
                <input type="text" class="form-control" v-model="formData.name">
                <label class="error" v-if="this.errors_category.name">{{this.errors_category.name[0]}}</label>
            </div>

            <div class="col-sm-12">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>
        </form>
    </div>
</template>

<script>
    export default {
        props: {
            isUpdate: {
                require: false,
                type: Boolean,
                default: false,
            },

            formData: {
                require: false,
                type: Object,
                default: () => {
                    return {
                        name: '',
                    }
                }
            }
        },
        data() {
            return {
                errors_category: {
                    name: ''
                }
            }
        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            }
        },

        methods: {
            onSubmit() {
                const action = this.isUpdate ? 'updateProductCategory' : 'storeProductCategory'
                const msg = this.isUpdate ? 'Grupo de produtos editado com sucesso' :
                    'Grupo de produtos cadastrado com sucesso.'
                this.$store.dispatch(action, this.formData)
                    .then(() => {
                        this.$snotify.success(msg)
                        this.$router.push({name: 'product-categories'})
                    })
                    .catch((error) => {
                        this.errors_category = error.response.data.errors
                    })
            },

            resetFormData() {
                this.formData = {
                    name: ''
                }
            },

            backPage() {
                return this.$router.push({name: 'product-categories'})
            }
        }
    }
</script>